package com.prolog.eis.service.out.impl;

import com.prolog.eis.dao.out.BizOutboundTaskHisMapper;
import com.prolog.eis.model.outbound.BizOutboundTaskHis;
import com.prolog.eis.service.out.BizOutboundTaskHisService;
import com.prolog.framework.core.restriction.Criteria;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 出库任务表-服务实现类
 * @date 2023-08-30 12:24
 */
@Service
public class BizOutboundTaskHisServiceImpl implements BizOutboundTaskHisService {

    @Autowired
    private BizOutboundTaskHisMapper bizOutboundTaskHisMapper;

    /**
     * 新增数据
     *
     * @param bizOutboundTaskHis 出库任务表
     */
    @Override
    public long save(BizOutboundTaskHis bizOutboundTaskHis) {
        return bizOutboundTaskHisMapper.save(bizOutboundTaskHis);
    }

    /**
     * 新增批量数据
     *
     * @param bizOutboundTaskHisList 出库任务表
     */
    @Override
    public long saveBatch(List<BizOutboundTaskHis> bizOutboundTaskHisList) {
        return bizOutboundTaskHisMapper.saveBatch(bizOutboundTaskHisList);
    }

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskHis> findByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskHisMapper.findByMap(paramMap, BizOutboundTaskHis.class);
    }

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    @Override
    public BizOutboundTaskHis findOneByMap(Map<String, Object> paramMap) {
        List<BizOutboundTaskHis> dataList = findByMap(paramMap);
        if(dataList.isEmpty()) {
            return null;
        }
        return dataList.get(0);
    }

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskHis> findByCriteria(Criteria criteria) {
        return bizOutboundTaskHisMapper.findByCriteria(criteria);
    }

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public BizOutboundTaskHis findById(int id) {
        return bizOutboundTaskHisMapper.findById(id, BizOutboundTaskHis.class);
    }

    /**
     * 修改数据
     *
     * @param bizOutboundTaskHis 实例对象
     */
    @Override
    public long update(BizOutboundTaskHis bizOutboundTaskHis) {
        return bizOutboundTaskHisMapper.update(bizOutboundTaskHis);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    @Override
    public long deleteById(int id) {
        return bizOutboundTaskHisMapper.deleteById(id, BizOutboundTaskHis.class);
    }

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    @Override
    public long deleteByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskHisMapper.deleteByMap(paramMap, BizOutboundTaskHis.class);
    }

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    @Override
    public long findCountByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskHisMapper.findCountByMap(paramMap, BizOutboundTaskHis.class);
    }
}
